
@--------------------------------
@ returns a string (unicode) created from w_sprintf() format and call_time structure
@ format must be specified in R0, structure has constant location (RAM)

.thumb_func
w_sprintf_duration:
push {r4-r6,lr}
mov  r6,r0
sub  sp,#16
mov  r5,sp

ldr  r4,_call_time
ldrb r0,[r4,#0]
add  r1,r5,#0
bl   ntoa2
ldrb r0,[r4,#1]
add  r1,r5,#3
bl   ntoa2
ldrb r0,[r4,#2]
add  r1,r5,#6
bl   ntoa2

mov  r0,r6
add  r1,r5,#0
add  r2,r5,#3
add  r3,r5,#6
bl   w_sprintf

add  sp,#16
pop  {r4-r6,pc}

@--------------------------------
@ main standby 5e0 function hook
@ works by interpreting call time messages

.global hook_standby
hook_standby:

push {r4-r5,lr}

ldr  r1,_msg_899
cmp  r0,r1
beq  start
add  r1,#1
cmp  r0,r1
beq  abort
ldr  r1,_msg_af1
cmp  r0,r1
beq  increment
ldr  r1,_msg_1e20
cmp  r0,r1
beq  disp_time
ldr  r1,_msg_1e21
cmp  r0,r1
beq  update
b    end

start:
ldr  r0,_status
mov  r1,#0
strb r1,[r0]

adr  r0,_msg_1e21
mov  r1,#2
mov  r2,#30
bl   own_timer_start
b    end

increment:
ldr  r0,_msg_1e21
bl   send_message
b    end

abort:
ldr  r0,_status
ldrb r1,[r0]
cmp  r1,#0
beq  end
mov  r1,#0
strb r1,[r0]

adr  r0,_msg_1e20
mov  r1,#2
mov  r2,#100
bl   own_timer_start
b    end

disp_time:
ldr  r0,_str_call_time
bl   w_sprintf_duration
mov  r2,r0
mov  r1,#2
ldr  r0,_msg_8226
bl   send_message
b    end

update:
ldr  r0,_config_id
bl   own_get_config
cmp  r0,#0
beq  end

ldr  r0,_status
mov  r1,#1
strb r1,[r0]

@ check that dial_number_buf is empty and Network Monitor is off
ldr  r0,_dial_number_buf
ldr  r1,_netmonitor_status
ldrb r0,[r0]
ldrb r1,[r1]
orr  r0,r1
bne  end

@ check message sent by main navi key
@ (must be 0xaba, 0xaca or 0xc8[arg=0xf])
ldr  r0,_current_action
ldrb r0,[r0]
ldr  r1,_actions_table
lsl  r0,r0,#5
add  r1,r1,r0
ldrh r0,[r1,#4]
ldr  r2,_msg_aba
cmp  r0,r2
beq  update_sub
add  r2,#0x10           @ 0xACA
cmp  r0,r2
beq  update_sub
cmp  r0,#0xc8
bne  end
ldr  r0,[r1,#8]
cmp  r0,#0xf
bne  end

update_sub:
sub  sp,#4
mov  r5,sp

adr  r0,_format
bl   w_sprintf_duration
mov  r4,r0

ldr  r0,_font_name
bl   own_get_font
mov  r3,r0
mov  r0,#1
str  r0,[r5] @ stack
mov  r0,r4
.global mov_left
mov_left:
mov  r1,#0
.global mov_top
mov_top:
mov  r2,#0
bl   own_print_string
bl   screen_to_lcd

add  sp,#4
@b    end

end:
pop  {r4-r5,pc}

@--------------------------------

.align

_call_time:
.long call_time

_font_name:
.long font_name

_config_id:
.long config_id

_str_call_time:
.long str_call_time

_current_action:
.long current_action

_actions_table:
.long actions_table

_dial_number_buf:
.long dial_number_buf

_netmonitor_status:
.long netmonitor_status

_msg_899:
.long 0x899

_msg_af1:
.long 0xaf1

_msg_1e20:
.long 0x1e20

_msg_1e21:
.long 0x1e21

_msg_8226:
.long 0x8226

_msg_aba:
.long 0xaba

_status:
.long status

.align
_format:
.asciz "%0S:%1S:%2S"

.bss

status:
.space 2
@ +0 : =0 at start, =1 at update

